package com.wechi.adweb.bridge.google.gtm.controller;

import com.wechi.adweb.bridge.common.APIStatus;
import com.wechi.adweb.bridge.common.BaseController;
import com.wechi.adweb.bridge.common.OpenAPIResponse;
import com.wechi.adweb.bridge.exception.DataException;
import com.wechi.adweb.bridge.google.gtm.dto.GTMAccountDTO;
import com.wechi.adweb.bridge.google.gtm.service.GTMService;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author wfansh
 */
@Slf4j
@RestController
@RequestMapping("/api/google/gtm")
public class GTMController extends BaseController {

    @Autowired private GTMService gtmService;

    @PostMapping("/accounts/list")
    @ResponseBody
    public OpenAPIResponse<List<GTMAccountDTO>> listGTMAccounts() throws DataException {
        long start = System.currentTimeMillis();
        log.info("****** listGTMAccounts() ******");

        List<GTMAccountDTO> gtmAccounts = gtmService.listGTMAccounts();

        log.info("****** listGTMAccounts() ****** duration = {} seconds", getElapsedSeconds(start));
        return OpenAPIResponse.<List<GTMAccountDTO>>builder()
                .status(APIStatus.SUCCESS)
                .data(gtmAccounts)
                .build();
    }
}
